#line 1 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker Accel Click/PIC Clicker Accel Click.c"
#line 43 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker Accel Click/PIC Clicker Accel Click.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;

char kk;
char i;


sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

sbit ACCEL_CS at RB3_bit;
sbit ACCEL_CS_Dir at TRISB3_bit;

unsigned short temp;
char out[16];
int readings[3] = {0, 0, 0};
short address, buffer;


void interrupt() {

 USB_Interrupt_Proc();
}

void clear_USB_buffers()
{
 for (i=0; i<63;i++)
 {
 readbuff[i] = 0;
 writebuff[i] = 0;
 }
}

char read_button1() {
 if (Button(&PORTD, 3, 2, 0)) {
 return 1;
 } else return 0;
}

char read_button2() {
 if (Button(&PORTD, 2, 2, 0)) {
 return 2;
 } else return 0;
}

void ADXL345_Write(unsigned short address, unsigned short data1) {
 I2C2_Start();
 I2C2_Wr( 0x3A );
 I2C2_Wr(address);
 I2C2_Wr(data1);
 I2C2_Stop();
}

unsigned short ADXL345_Read(unsigned short address) {
 unsigned short tmp = 0;

 I2C2_Start();
 I2C2_Wr( 0x3A );
 I2C2_Wr(address);

 I2C2_Start();
 I2C2_Wr( 0x3A +1);
 tmp = I2C2_Rd(0);
 I2C2_Stop();

 return tmp;
}

char ADXL345_Init(void) {
 char id = 0x00;


 ADXL345_Write(0x2D, 0x00);

 id = ADXL345_Read(0x00);
 if (id != 0xE5) {
 return  0x02 ;
 }
 else {
 ADXL345_Write( 0x31 , 0x08);
 ADXL345_Write( 0x2C , 0x0A);
 ADXL345_Write( 0x38 , 0x80);
 ADXL345_Write( 0x2D , 0x08);
 return 0x00;
 }
}


int Accel_ReadX(void) {
 char low_byte;
 int Out_x;

 Out_x = ADXL345_Read( 0x33 );
 low_byte = ADXL345_Read( 0x32 );

 Out_x = (Out_x << 8);
 Out_x = (Out_x | low_byte);

 return Out_x;
}


int Accel_ReadY(void) {
 char low_byte;
 int Out_y;

 Out_y = ADXL345_Read( 0x35 );
 low_byte = ADXL345_Read( 0x34 );

 Out_y = (Out_y << 8);
 Out_y = (Out_y | low_byte);

 return Out_y;
}


int Accel_ReadZ(void) {
 char low_byte;
 int Out_z;

 Out_z = ADXL345_Read( 0x37 );
 low_byte = ADXL345_Read( 0x36 );

 Out_z = (Out_z << 8);
 Out_z = (Out_z | low_byte);

 return Out_z;
}


void Accel_Average(void) {
 int i, sx, sy, sz;


 sx = sy = sz = 0;


 for (i=0; i<16; i++) {
 sx += Accel_ReadX();
 sy += Accel_ReadY();
 sz += Accel_ReadZ();
 }

 readings[0] = sx >> 4;
 readings[1] = sy >> 4;
 readings[2] = sz >> 4;

}

void AccelInit(){

 if (ADXL345_Init() == 0) {

 Delay_ms(2000);
 }
 else {

 Delay_ms(2000);
 }
}

void load_X() {

 for (i =0;i <10;i++) {
 writebuff[1+i]= out[i];
 }
}

void load_Y() {

 for (i =0;i <10;i++) {
 writebuff[11+i]= out[i];
 }
}

void load_Z() {

 for (i =0;i <10;i++) {
 writebuff[21+i]= out[i];
 }
}

void main(){
 long cnt = 0;

 ANCON0 = 0xFF;
 ANCON1 = 0x1F;
 TRISD = 0;
 TRISB = 0;
 TRISA = 0;
 RCSTA1 = 1;


 T1_Direction = 1;
 T2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 ACCEL_CS_Dir = 0;
 ACCEL_CS = 1;

 I2C2_Init(50000);
 Delay_ms(1000);
 AccelInit();
 Delay_ms(150);


 clear_USB_buffers();
 HID_Enable(&readbuff,&writebuff);


 while (1){
 Accel_Average();

 kk = HID_Read();
 if (kk != 0)
 {

 IntToStr(readings[0], out);
 load_X();
 IntToStr(readings[1], out);
 load_Y();
 IntToStr(readings[2], out);
 load_Z();

 if ((readbuff[0] & 0x01 )> 0) {
 LD1 = 1;
 } else LD1 = 0;
 if ((readbuff[0] & 0x02 )> 0) {
 LD2 = 1;
 } else LD2 = 0;

 writebuff[0]=0;
 writebuff[0] = writebuff[0] | read_button1() ;
 writebuff[0] = writebuff[0] | read_button2() ;

 HID_Write(&writebuff,64);
 }
 }
}
